import os

from flask import request, send_file, after_this_request, Blueprint

from pyrest.utils.timelapse.Timelapse import TimelapseFactory


timelapse_api = Blueprint('timelapse', __name__)

@timelapse_api.route("/timelapse")
def getTimelapseInfo():
    return "<h1>Welcome to the timelapse API</h1>"

@timelapse_api.route("/timelapse/<type>", methods = ['POST'])
def createTimelapse(type):
    data = request.json
    timelapse = TimelapseFactory.factory(type.upper())

    for image in data["images"]:
        timelapse.addWMSImage(image)

    file_path = timelapse.create(data["settings"]["delay"], 0 if data["settings"]["loop"] == "true" else 1)

    @after_this_request
    def remove_file(response):
        os.remove(file_path)
        os.rmdir(os.path.abspath(os.path.join(file_path, os.pardir)))
        return response
    return send_file(file_path, 'image/gif')
